SDL_thread.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "SDL_atomic.h"`
`#include "SDL_mutex.h"`
`#include <process.h>`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_thread.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_PASSED_BEGINTHREAD_ENDTHREAD
#define | SDL_beginthread _beginthreadex
#define | SDL_endthread _endthreadex
#define | SDL_CreateThread(fn, name, data)
#define | SDL_CreateThreadWithStackSize(fn, name, stacksize, data)

## Typedefs

typedef struct SDL_Thread | SDL_Thread
typedef unsigned long | SDL_threadID
typedef unsigned int | SDL_TLSID
typedef int(* | SDL_ThreadFunction) (void *data)
typedef uintptr_t(__cdecl * | pfnSDL_CurrentBeginThread) (void *, unsigned, unsigned(__stdcall *func) (void *), void *, unsigned, unsigned *)
typedef void(__cdecl * | pfnSDL_CurrentEndThread) (unsigned code)
typedef void(* | SDL_TLSDestructorCallback) (void *)

## Enumerations

enum | SDL_ThreadPriority { SDL_THREAD_PRIORITY_LOW , SDL_THREAD_PRIORITY_NORMAL , SDL_THREAD_PRIORITY_HIGH , SDL_THREAD_PRIORITY_TIME_CRITICAL }

## Functions

SDL_Thread * | SDL_CreateThread (SDL_ThreadFunction fn, const char *name, void *data, pfnSDL_CurrentBeginThread pfnBeginThread, pfnSDL_CurrentEndThread pfnEndThread)
SDL_Thread * | SDL_CreateThreadWithStackSize (SDL_ThreadFunction fn, const char *name, const size_t stacksize, void *data, pfnSDL_CurrentBeginThread pfnBeginThread, pfnSDL_CurrentEndThread pfnEndThread)
const char * | SDL_GetThreadName (SDL_Thread *thread)
SDL_threadID | SDL_ThreadID (void)
SDL_threadID | SDL_GetThreadID (SDL_Thread *thread)
int | SDL_SetThreadPriority (SDL_ThreadPriority priority)
void | SDL_WaitThread (SDL_Thread *thread, int *status)
void | SDL_DetachThread (SDL_Thread *thread)
SDL_TLSID | SDL_TLSCreate (void)
void * | SDL_TLSGet (SDL_TLSID id)
int | SDL_TLSSet (SDL_TLSID id, const void *value, SDL_TLSDestructorCallback destructor)
void | SDL_TLSCleanup (void)

## Detailed Description

We compile SDL into a DLL. This means, that it's the DLL which creates a new thread for the calling process with the SDL_CreateThread() API. There is a problem with this, that only the RTL of the SDL2.DLL will be initialized for those threads, and not the RTL of the calling application!

To solve this, we make a little hack here.

We'll always use the caller's _beginthread() and _endthread() APIs to start a new thread. This way, if it's the SDL2.DLL which uses this API, then the RTL of SDL2.DLL will be used to create the new thread, and if it's the application, then the RTL of the application will be used.

So, in short: Always use the _beginthread() and _endthread() of the calling runtime library!

Definition in file SDL_thread.h.

## Macro Definition Documentation

## SDL_beginthread

#define SDL_beginthread _beginthreadex

Definition at line 122 of file SDL_thread.h.

## SDL_CreateThread

#define SDL_CreateThread | ( |  | fn,
|  |  | name,
|  |  | data )

Value:
SDL_CreateThread(fn, name, data, (pfnSDL_CurrentBeginThread)SDL_beginthread, (pfnSDL_CurrentEndThread)SDL_endthread)
SDL_endthread
#define SDL_endthread
Definition SDL_thread.h:125
pfnSDL_CurrentEndThread
void(__cdecl * pfnSDL_CurrentEndThread)(unsigned code)
Definition SDL_thread.h:119
SDL_beginthread
#define SDL_beginthread
Definition SDL_thread.h:122
SDL_CreateThread
#define SDL_CreateThread(fn, name, data)
Definition SDL_thread.h:146
pfnSDL_CurrentBeginThread
uintptr_t(__cdecl * pfnSDL_CurrentBeginThread)(void *, unsigned, unsigned(__stdcall *func)(void *), void *, unsigned, unsigned *)
Definition SDL_thread.h:117

Definition at line 146 of file SDL_thread.h.

## SDL_CreateThreadWithStackSize

#define SDL_CreateThreadWithStackSize | ( |  | fn,
|  |  | name,
|  |  | stacksize,
|  |  | data )

Value:
SDL_CreateThreadWithStackSize(fn, name, stacksize, data, (pfnSDL_CurrentBeginThread)SDL_beginthread, (pfnSDL_CurrentEndThread)SDL_endthread)
SDL_CreateThreadWithStackSize
#define SDL_CreateThreadWithStackSize(fn, name, stacksize, data)
Definition SDL_thread.h:147

Definition at line 147 of file SDL_thread.h.

## SDL_endthread

#define SDL_endthread _endthreadex

Definition at line 125 of file SDL_thread.h.

## SDL_PASSED_BEGINTHREAD_ENDTHREAD

#define SDL_PASSED_BEGINTHREAD_ENDTHREAD

Definition at line 114 of file SDL_thread.h.

## Typedef Documentation

## pfnSDL_CurrentBeginThread

typedef uintptr_t(__cdecl * pfnSDL_CurrentBeginThread) (void *, unsigned, unsigned(__stdcall *func)(void *), void *, unsigned, unsigned *)

Definition at line 116 of file SDL_thread.h.

## pfnSDL_CurrentEndThread

typedef void(__cdecl * pfnSDL_CurrentEndThread) (unsigned code)

Definition at line 119 of file SDL_thread.h.

## SDL_Thread

typedef struct SDL_Thread SDL_Thread

Definition at line 57 of file SDL_thread.h.

## SDL_ThreadFunction

typedef int(* SDL_ThreadFunction) (void *data)

The function passed to SDL_CreateThread().

Parameters

  data | what was passed as data to SDL_CreateThread().

Returns
  a value that can be reported through SDL_WaitThread().

Definition at line 90 of file SDL_thread.h.

## SDL_threadID

typedef unsigned long SDL_threadID

Definition at line 60 of file SDL_thread.h.

## SDL_TLSDestructorCallback

typedef void(* SDL_TLSDestructorCallback) (void *)

Definition at line 426 of file SDL_thread.h.

## SDL_TLSID

typedef unsigned int SDL_TLSID

Definition at line 63 of file SDL_thread.h.

## Enumeration Type Documentation

## SDL_ThreadPriority

enum SDL_ThreadPriority

The SDL thread priority.

SDL will make system changes as necessary in order to apply the thread priority. Code which attempts to control thread state related to priority should be aware that calling SDL_SetThreadPriority may alter such state. SDL_HINT_THREAD_PRIORITY_POLICY can be used to control aspects of this behavior.

On many systems you require special privileges to set high or time critical priority.

Enumerator
SDL_THREAD_PRIORITY_LOW |
SDL_THREAD_PRIORITY_NORMAL |
SDL_THREAD_PRIORITY_HIGH |
SDL_THREAD_PRIORITY_TIME_CRITICAL |

Definition at line 77 of file SDL_thread.h.

{
SDL_THREAD_PRIORITY_LOW,
SDL_THREAD_PRIORITY_NORMAL,
SDL_THREAD_PRIORITY_HIGH,
SDL_THREAD_PRIORITY_TIME_CRITICAL
} SDL_ThreadPriority;
SDL_ThreadPriority
SDL_ThreadPriority
Definition SDL_thread.h:77
SDL_THREAD_PRIORITY_TIME_CRITICAL
@ SDL_THREAD_PRIORITY_TIME_CRITICAL
Definition SDL_thread.h:81
SDL_THREAD_PRIORITY_LOW
@ SDL_THREAD_PRIORITY_LOW
Definition SDL_thread.h:78
SDL_THREAD_PRIORITY_HIGH
@ SDL_THREAD_PRIORITY_HIGH
Definition SDL_thread.h:80
SDL_THREAD_PRIORITY_NORMAL
@ SDL_THREAD_PRIORITY_NORMAL
Definition SDL_thread.h:79

## Function Documentation

## SDL_CreateThread()

SDL_Thread * SDL_CreateThread | ( | SDL_ThreadFunction | fn,
|  | const char * | name,
|  | void * | data,
|  | pfnSDL_CurrentBeginThread | pfnBeginThread,
|  | pfnSDL_CurrentEndThread | pfnEndThread )

extern

## SDL_CreateThreadWithStackSize()

SDL_Thread * SDL_CreateThreadWithStackSize | ( | SDL_ThreadFunction | fn,
|  | const char * | name,
|  | const size_t | stacksize,
|  | void * | data,
|  | pfnSDL_CurrentBeginThread | pfnBeginThread,
|  | pfnSDL_CurrentEndThread | pfnEndThread )

extern

## SDL_DetachThread()

void SDL_DetachThread | ( | SDL_Thread * | thread | ) |

extern

Let a thread clean up on exit without intervention.

A thread may be "detached" to signify that it should not remain until another thread has called SDL_WaitThread() on it. Detaching a thread is useful for long-running threads that nothing needs to synchronize with or further manage. When a detached thread is done, it simply goes away.

There is no way to recover the return code of a detached thread. If you need this, don't detach the thread and instead use SDL_WaitThread().

Once a thread is detached, you should usually assume the SDL_Thread isn't safe to reference again, as it will become invalid immediately upon the detached thread's exit, instead of remaining until someone has called SDL_WaitThread() to finally clean it up. As such, don't detach the same thread more than once.

If a thread has already exited when passed to SDL_DetachThread(), it will stop waiting for a call to SDL_WaitThread() and clean up immediately. It is not safe to detach a thread that might be used with SDL_WaitThread().

You may not call SDL_WaitThread() on a thread that has been detached. Use either that function or this one, but not both, or behavior is undefined.

It is safe to pass NULL to this function; it is a no-op.

Parameters

  thread | the SDL_Thread pointer that was returned from the SDL_CreateThread() call that started this thread.

Since
  This function is available since SDL 2.0.2.

See also
  SDL_CreateThread
  SDL_WaitThread

## SDL_GetThreadID()

SDL_threadID SDL_GetThreadID | ( | SDL_Thread * | thread | ) |

extern

Get the thread identifier for the specified thread.

This thread identifier is as reported by the underlying operating system. If SDL is running on a platform that does not support threads the return value will always be zero.

Parameters

  thread | the thread to query.

Returns
  the ID of the specified thread, or the ID of the current thread if thread is NULL.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_ThreadID

## SDL_GetThreadName()

const char * SDL_GetThreadName | ( | SDL_Thread * | thread | ) |

extern

Get the thread name as it was specified in SDL_CreateThread().

This is internal memory, not to be freed by the caller, and remains valid until the specified thread is cleaned up by SDL_WaitThread().

Parameters

  thread | the thread to query.

Returns
  a pointer to a UTF-8 string that names the specified thread, or NULL if it doesn't have a name.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateThread

## SDL_SetThreadPriority()

int SDL_SetThreadPriority | ( | SDL_ThreadPriority | priority | ) |

extern

Set the priority for the current thread.

Note that some platforms will not let you alter the priority (or at least, promote the thread to a higher priority) at all, and some require you to be an administrator account. Be prepared for this to fail.

Parameters

  priority | the SDL_ThreadPriority to set.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

## SDL_ThreadID()

SDL_threadID SDL_ThreadID | ( | void |  | ) |

extern

Get the thread identifier for the current thread.

This thread identifier is as reported by the underlying operating system. If SDL is running on a platform that does not support threads the return value will always be zero.

This function also returns a valid thread ID when called from the main thread.

Returns
  the ID of the current thread.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetThreadID

## SDL_TLSCleanup()

void SDL_TLSCleanup | ( | void |  | ) |

extern

Cleanup all TLS data for this thread.

Since
  This function is available since SDL 2.0.16.

## SDL_TLSCreate()

SDL_TLSID SDL_TLSCreate | ( | void |  | ) |

extern

Create a piece of thread-local storage.

This creates an identifier that is globally visible to all threads but refers to data that is thread-specific.

Returns
  the newly created thread local storage identifier or 0 on error.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_TLSGet
  SDL_TLSSet

## SDL_TLSGet()

void * SDL_TLSGet | ( | SDL_TLSID | id | ) |

extern

Get the current thread's value associated with a thread local storage ID.

Parameters

  id | the thread local storage ID.

Returns
  the value associated with the ID for the current thread or NULL if no value has been set; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_TLSCreate
  SDL_TLSSet

## SDL_TLSSet()

int SDL_TLSSet | ( | SDL_TLSID | id,
|  | const void * | value,
|  | SDL_TLSDestructorCallback | destructor )

extern

Set the current thread's value associated with a thread local storage ID.

The function prototype for destructor is:

void destructor(void *value)

where its parameter value is what was passed as value to SDL_TLSSet().

Parameters

  id | the thread local storage ID.
  value | the value to associate with the ID for the current thread.
  destructor | a function called when the thread exits, to free the value.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_TLSCreate
  SDL_TLSGet

## SDL_WaitThread()

void SDL_WaitThread | ( | SDL_Thread * | thread,
|  | int * | status )

extern

Wait for a thread to finish.

Threads that haven't been detached will remain (as a "zombie") until this function cleans them up. Not doing so is a resource leak.

Once a thread has been cleaned up through this function, the SDL_Thread that references it becomes invalid and should not be referenced again. As such, only one thread may call SDL_WaitThread() on another.

The return code for the thread function is placed in the area pointed to by status, if status is not NULL.

You may not wait on a thread that has been used in a call to SDL_DetachThread(). Use either that function or this one, but not both, or behavior is undefined.

It is safe to pass a NULL thread to this function; it is a no-op.

Note that the thread pointer is freed by this function and is not valid afterward.

Parameters

  thread | the SDL_Thread pointer that was returned from the SDL_CreateThread() call that started this thread.
  status | pointer to an integer that will receive the value returned from the thread function by its 'return', or NULL to not receive such value back.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateThread
  SDL_DetachThread